package com.tmax.openframe.variable;

import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.variable.group.*;
import java.math.*;
import java.text.DecimalFormat;
import java.util.*;
import java.util.function.BiFunction;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public class OIVPINFO_VariableContainer {
    public @Getter String WS_DATE = StringUtils.repeat(' ', 8);
    public @Getter String WS_TERM = StringUtils.repeat(' ', 4);
    public @Getter @Setter OIVPINFO_WS_RAW_TIME WS_RAW_TIME = new OIVPINFO_WS_RAW_TIME();
    public @Getter @Setter long WS_ASKTIME;
    public @Getter @Setter OIVPINFO_DFHCOMMAREA DFHCOMMAREA = new OIVPINFO_DFHCOMMAREA();
    private final static BiFunction<Long, String, String> intFormatWithSign = (
            value, format) -> {
        DecimalFormat nf = new DecimalFormat();
        nf.applyPattern("+" + format + ";-" + format);
        return nf.format(value);
    };

    public void setWS_DATE(String source) {
        WS_DATE = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public void setWS_TERM(String source) {
        WS_TERM = StringUtils.truncate(StringUtils.rightPad(source, 4), 4);
    }

    public String getStringWS_ASKTIME() {
        return intFormatWithSign.apply(WS_ASKTIME, "000000000000000");
    }
}
